/*
 * 助利宝分润
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class HelpProfitRewardController : BaseController
    {
        public HelpProfitRewardController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 助利宝分润列表

        /// <summary>
        /// 根据条件查询助利宝分润列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(HelpProfitReward data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询助利宝分润列表

        /// <summary>
        /// 助利宝分润列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(HelpProfitReward data, string BrandIdSelect, string CheckStatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("TradeDate", "3"); //达标日期


            string condition = " and Status>-1";
            //品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //验证和同步账户状态
            if (!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitReward", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //品牌
                dic["BrandId"] = RelationClass.GetKqProductsInfo(int.Parse(dic["BrandId"].ToString()));
                //奖励类型
                int RewardType = int.Parse(dic["RewardType"].ToString());
                if (RewardType == 1) dic["RewardType"] = "分润";
                if (RewardType == 112) dic["RewardType"] = "推荐奖励";
                if (RewardType == 0) dic["RewardType"] = "";
                //验证和同步账户状态
                int Status = int.Parse(dic["Status"].ToString());
                if (Status == 0) dic["Status"] = "初始";
                if (Status == 1) dic["Status"] = "已展示";
                if (Status == 2) dic["Status"] = "已到账";

            }
            return Json(obj);
        }

        #endregion

        #region 增加助利宝分润

        /// <summary>
        /// 增加或修改助利宝分润信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加助利宝分润

        /// <summary>
        /// 增加或修改助利宝分润信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(HelpProfitReward data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("HelpProfitReward", Fields, 0);
            AddSysLog(data.Id.ToString(), "HelpProfitReward", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改助利宝分润

        /// <summary>
        /// 增加或修改助利宝分润信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            HelpProfitReward editData = db.HelpProfitReward.FirstOrDefault(m => m.Id == Id) ?? new HelpProfitReward();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改助利宝分润

        /// <summary>
        /// 增加或修改助利宝分润信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(HelpProfitReward data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitReward", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "HelpProfitReward", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除助利宝分润信息

        /// <summary>
        /// 删除助利宝分润信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitReward", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitReward", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitReward", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitReward", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitReward", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitReward", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("HelpProfitReward", Sort, Id);

            AddSysLog(Id.ToString(), "HelpProfitReward", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.HelpProfitReward.Add(new HelpProfitReward()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "HelpProfitReward", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(HelpProfitReward data, string BrandIdSelect, string CheckStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("TradeDate", "3"); //达标日期


            string condition = " and Status>-1";
            //品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //验证和同步账户状态
            if (!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitReward", Fields, "Id desc", "0", 1, 20000, condition, "TradeDate,UserId,BrandId,RewardType,CreditTradeAmt,DebitTradeAmt,CreditRewardAmount,DebitRewardAmount,RewardMerCount,CheckStatus", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //品牌
                dic["BrandId"] = RelationClass.GetKqProductsInfo(int.Parse(dic["BrandId"].ToString()));
                //奖励类型
                int RewardType = int.Parse(dic["RewardType"].ToString());
                if (RewardType == 1) dic["RewardType"] = "分润";
                if (RewardType == 112) dic["RewardType"] = "推荐奖励";
                if (RewardType == 0) dic["RewardType"] = "";
                //验证和同步账户状态
                int CheckStatus = int.Parse(dic["CheckStatus"].ToString());
                if (CheckStatus == 0) dic["CheckStatus"] = "初始";
                if (CheckStatus == 1) dic["CheckStatus"] = "已验证和同步";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("TradeDate", "达标日期");
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("BrandId", "品牌");
            ReturnFields.Add("RewardType", "奖励类型");
            ReturnFields.Add("CreditTradeAmt", "贷记卡交易总金额");
            ReturnFields.Add("DebitTradeAmt", "借记卡交易总金额");
            ReturnFields.Add("CreditRewardAmount", "贷记卡交易奖励金额");
            ReturnFields.Add("DebitRewardAmount", "借记记卡交易奖励金额");
            ReturnFields.Add("RewardMerCount", "达标商户数");
            ReturnFields.Add("CheckStatus", "验证和同步账户状态");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "HelpProfitReward", "ExportExcel");
            return Json(result);
        }

        #endregion




        #region 同步到余额

        public string SycnData(int OpType = 0)
        {
            string date = DateTime.Now.AddMonths(-1).ToString("yyyyMM");
            string OpTypeString = "";
            if(OpType > 0)
            {
                OpTypeString += "-" + OpType;
            }
            string check = function.ReadInstance("/HelpBalance/" + date + OpTypeString + ".txt");
            if (string.IsNullOrEmpty(check))
            {
                function.WritePage("/HelpBalance/", date + OpTypeString + ".txt", DateTime.Now.ToString());
                RedisDbconn.Instance.AddList("SycnHelpProfitQueue2", date + "#cut#" + OpType + "#cut#" + SysUserName);
                return "success";
            }
            return date + "分润已同步，请勿重复操作";
        }

        #endregion

    }
}
